【二分答案+贪心】解决“最小值最大”问题(UVa 12124

Problem A - Assemble

Time limit: 2 seconds

Recently your team noticed that the computer you use to practice for programming contests is not good enough anymore. Therefore, you decide to buy a new computer.

To make the ideal computer for your needs, you decide to buy separate components and assemble the computer yourself. You need to buy exactly one of each type of component.

The problem is which components to buy. As you all know, the quality of a computer is equal to the quality of its weakest component. Therefore, you want to maximize the quality of the component with the lowest quality, while not exceeding your budget.

Input

On the first line one positive number: the number of testcases, at most 100. After that per testcase:

  • One line with two integers: 1 ≤ n ≤ 1000, the number of available components and 1 ≤ b ≤ 1000000000, your budget.
  • n lines in the following format: ``type name price quality'', where type is a string with the type of the component, name is a string with the unique name of the component, price is an integer (0 ≤ price < 1000000) which represents the price of the component and quality is an integer (0 ≤ quality ≤ 1000000000) which represents the quality of the component (higher is better). The strings contain only letters, digits and underscores and have a maximal length of 20 characters.

It will always possible to construct a computer with your budget.

Output

Per testcase:

  • One line with one integer: the maximal possible quality.

Sample Input

1
18 800
processor 3500_MHz 66 5
processor 4200_MHz 103 7
processor 5000_MHz 156 9
processor 6000_MHz 219 12
memory 1_GB 35 3
memory 2_GB 88 6
memory 4_GB 170 12
mainbord all_onboard 52 10
harddisk 250_GB 54 10
harddisk 500_FB 99 12
casing midi 36 10
monitor 17_inch 157 5
monitor 19_inch 175 7
monitor 20_inch 210 9
monitor 22_inch 293 12
mouse cordless_optical 18 12
mouse microsoft 30 9
keyboard office 4 10

Sample Output

9
The 2007 ACM Northwestern European Programming Contest
 
题意:你要去自己买个组装机,现在给你每个零件的类别、名字、价钱、级别,以及你有的钱数,求能组装成的机器的最大级别(机器的所有零件中的最小级别,即最小值最大)。
 
解决“最小值最大”问题的常用方法是“二分答案”。
何为二分答案?以本题为例,假设机器的所有零件中的最小级别为x,删除级别小于x的所有配件,若可以组装成一台不超过b元的电脑,那么ans≥x, 否则ans<x;
 
至于如何判断是否可以组装出不超过b元的电脑。利用贪心的思路,每种配件选择最便宜的一个即可。
 
二分部分代码:
1 while(L < R)
2 {
3     int M = L+(R-L+1)/2;
4     if(ok(M)) L = M;
5     else R = M-1;
6 }

贪心部分代码:

 1 bool ok(int q)
 2 {
 3     int sum = 0;
 4     for(int i = 0; i < cnt; i++)
 5     {
 6         int sz = comp[i].size();
 7         int cheapest = b+1;
 8         for(int j = 0; j < sz; j++)
 9         {
10             if(comp[i][j].quality >= q)
11                 cheapest = min(cheapest, comp[i][j].price);//选择最便宜的
12         }
13         if(cheapest == b+1) return false;
14         sum += cheapest;
15         if(sum > b) return false;
16     }
17     return true;
18 }

代码如下:

 1 #include<iostream>
 2 #include<cstdio>
 3 #include<cstdlib>
 4 #include<cstring>
 5 #include<string>
 6 #include<vector>
 7 #include<map>
 8 using namespace std;
 9 const int maxn = 1010;
10 
11 struct Component
12 {
13     int price, quality;
14 };
15 vector<Component> comp[maxn];
16 int n, b, cnt;
17 
18 map<string, int> id;
19 int type_ID(string s)
20 {
21     if(!id.count(s)) id[s] = cnt++;
22     return id[s];
23 }
24 bool ok(int q)
25 {
26     int sum = 0;
27     for(int i = 0; i < cnt; i++)
28     {
29         int sz = comp[i].size();
30         int cheapest = b+1;
31         for(int j = 0; j < sz; j++)
32         {
33             if(comp[i][j].quality >= q)
34                 cheapest = min(cheapest, comp[i][j].price);
35         }
36         if(cheapest == b+1) return false;
37         sum += cheapest;
38         if(sum > b) return false;
39     }
40     return true;
41 }
42 int main()
43 {
44     int T; scanf("%d", &T);
45     while(T--)
46     {
47         scanf("%d%d", &n, &b);
48         int maxq = 0; cnt = 0; id.clear();
49         for(int i = 0; i < n; i++) comp[i].clear();
50         for(int i = 0; i < n; i++)
51         {
52             char type[30], name[30];    scanf("%s%s", type, name);
53             int pri, qua;               scanf("%d%d", &pri, &qua);
54             maxq = max(qua, maxq);
55             Component tmp; tmp.price = pri, tmp.quality = qua;
56             string tp(type);
57             comp[type_ID(tp)].push_back(tmp);
58         }
59         int L = 0, R = maxq;
60         while(L < R)
61         {
62             //cout << "-----" <<endl;
63             int M = L+(R-L+1)/2;
64             if(ok(M)) L = M;
65             else R = M-1;
66         }
67         printf("%d
", L);
68     }
69     return 0;
70 }
View Code
原文地址:https://www.cnblogs.com/LLGemini/p/4302832.html